package ex.vax;

import blang.core.ConstantSupplier;
import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.Param;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.io.GlobalDataSource;
import blang.types.Index;
import blang.types.Plate;
import blang.types.Plated;
import blang.types.StaticUtils;
import blang.types.internals.RealScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import ex.vax.Utils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Optional;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class Vaccines implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public GlobalDataSource data;
    
    private boolean data_initialized = false;
    
    public Vaccines.Builder setData(final GlobalDataSource data) {
      data_initialized = true;
      this.data = data;
      return this;
    }
    
    @Arg
    public Plate<String> trials;
    
    private boolean trials_initialized = false;
    
    public Vaccines.Builder setTrials(final Plate<String> trials) {
      trials_initialized = true;
      this.trials = trials;
      return this;
    }
    
    @Arg
    public Plate<String> arms;
    
    private boolean arms_initialized = false;
    
    public Vaccines.Builder setArms(final Plate<String> arms) {
      arms_initialized = true;
      this.arms = arms;
      return this;
    }
    
    @Arg
    public Plated<IntVar> groupSizes;
    
    private boolean groupSizes_initialized = false;
    
    public Vaccines.Builder setGroupSizes(final Plated<IntVar> groupSizes) {
      groupSizes_initialized = true;
      this.groupSizes = groupSizes;
      return this;
    }
    
    @Arg
    public Plated<IntVar> numbersOfCases;
    
    private boolean numbersOfCases_initialized = false;
    
    public Vaccines.Builder setNumbersOfCases(final Plated<IntVar> numbersOfCases) {
      numbersOfCases_initialized = true;
      this.numbersOfCases = numbersOfCases;
      return this;
    }
    
    @Arg
    public Plated<RealVar> efficacies;
    
    private boolean efficacies_initialized = false;
    
    public Vaccines.Builder setEfficacies(final Plated<RealVar> efficacies) {
      efficacies_initialized = true;
      this.efficacies = efficacies;
      return this;
    }
    
    @Arg
    public Plated<RealVar> incidences;
    
    private boolean incidences_initialized = false;
    
    public Vaccines.Builder setIncidences(final Plated<RealVar> incidences) {
      incidences_initialized = true;
      this.incidences = incidences;
      return this;
    }
    
    @Arg
    public Optional<RealVar> a;
    
    public Vaccines.Builder setA(final RealVar a) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.a = Optional.of(a);
      return this;
    }
    
    @Arg
    public Optional<RealVar> b;
    
    public Vaccines.Builder setB(final RealVar b) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.b = Optional.of(b);
      return this;
    }
    
    @Arg
    public Optional<RealVar> c;
    
    public Vaccines.Builder setC(final RealVar c) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.c = Optional.of(c);
      return this;
    }
    
    @Arg
    public Optional<RealVar> d;
    
    public Vaccines.Builder setD(final RealVar d) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.d = Optional.of(d);
      return this;
    }
    
    public Vaccines build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      if (!fromCommandLine && !data_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing data");
      final GlobalDataSource __data = data;
      if (!fromCommandLine && !trials_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing trials");
      final Plate<String> __trials = trials;
      if (!fromCommandLine && !arms_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing arms");
      final Plate<String> __arms = arms;
      if (!fromCommandLine && !groupSizes_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing groupSizes");
      final Plated<IntVar> __groupSizes = groupSizes;
      if (!fromCommandLine && !numbersOfCases_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing numbersOfCases");
      final Plated<IntVar> __numbersOfCases = numbersOfCases;
      if (!fromCommandLine && !efficacies_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing efficacies");
      final Plated<RealVar> __efficacies = efficacies;
      if (!fromCommandLine && !incidences_initialized)
        throw new RuntimeException("Not all fields were set in the builder, e.g. missing incidences");
      final Plated<RealVar> __incidences = incidences;
      RealVar a;
      if (this.a != null && this.a.isPresent()) {
        a = this.a.get();
      } else {
        a = $generated__23(data, trials, arms, groupSizes, numbersOfCases, efficacies, incidences);
      }
      final RealVar __a = a;
      RealVar b;
      if (this.b != null && this.b.isPresent()) {
        b = this.b.get();
      } else {
        b = $generated__24(data, trials, arms, groupSizes, numbersOfCases, efficacies, incidences, a);
      }
      final RealVar __b = b;
      RealVar c;
      if (this.c != null && this.c.isPresent()) {
        c = this.c.get();
      } else {
        c = $generated__25(data, trials, arms, groupSizes, numbersOfCases, efficacies, incidences, a, b);
      }
      final RealVar __c = c;
      RealVar d;
      if (this.d != null && this.d.isPresent()) {
        d = this.d.get();
      } else {
        d = $generated__26(data, trials, arms, groupSizes, numbersOfCases, efficacies, incidences, a, b, c);
      }
      final RealVar __d = d;
      // Build the instance after boxing params
      return new Vaccines(
        __numbersOfCases, 
        __efficacies, 
        __incidences, 
        __a, 
        __b, 
        __c, 
        __d, 
        new ConstantSupplier(__data), 
        new ConstantSupplier(__trials), 
        new ConstantSupplier(__arms), 
        new ConstantSupplier(__groupSizes)
      );
    }
  }
  
  @DesignatedConstructor
  public static Vaccines.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  @Param
  private final Supplier<GlobalDataSource> $generated__data;
  
  public GlobalDataSource getData() {
    return $generated__data.get();
  }
  
  @Param
  private final Supplier<Plate<String>> $generated__trials;
  
  public Plate<String> getTrials() {
    return $generated__trials.get();
  }
  
  @Param
  private final Supplier<Plate<String>> $generated__arms;
  
  public Plate<String> getArms() {
    return $generated__arms.get();
  }
  
  @Param
  private final Supplier<Plated<IntVar>> $generated__groupSizes;
  
  public Plated<IntVar> getGroupSizes() {
    return $generated__groupSizes.get();
  }
  
  private final Plated<IntVar> numbersOfCases;
  
  public Plated<IntVar> getNumbersOfCases() {
    return numbersOfCases;
  }
  
  private final Plated<RealVar> efficacies;
  
  public Plated<RealVar> getEfficacies() {
    return efficacies;
  }
  
  private final Plated<RealVar> incidences;
  
  public Plated<RealVar> getIncidences() {
    return incidences;
  }
  
  private final RealVar a;
  
  public RealVar getA() {
    return a;
  }
  
  private final RealVar b;
  
  public RealVar getB() {
    return b;
  }
  
  private final RealVar c;
  
  public RealVar getC() {
    return c;
  }
  
  private final RealVar d;
  
  public RealVar getD() {
    return d;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * a
   */
  private static RealVar $generated__0(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    return a;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.001
   */
  private static RealVar $generated__1() {
    return new blang.core.RealConstant(0.001);
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1();
    }
    
    public String toString() {
      return "0.001";
    }
    
    public $generated__1_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * b
   */
  private static RealVar $generated__2(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    return b;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.001
   */
  private static RealVar $generated__3() {
    return new blang.core.RealConstant(0.001);
  }
  
  public static class $generated__3_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__3();
    }
    
    public String toString() {
      return "0.001";
    }
    
    public $generated__3_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * c
   */
  private static RealVar $generated__4(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    return c;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.001
   */
  private static RealVar $generated__5() {
    return new blang.core.RealConstant(0.001);
  }
  
  public static class $generated__5_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__5();
    }
    
    public String toString() {
      return "0.001";
    }
    
    public $generated__5_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * d
   */
  private static RealVar $generated__6(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    return d;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.001
   */
  private static RealVar $generated__7() {
    return new blang.core.RealConstant(0.001);
  }
  
  public static class $generated__7_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__7();
    }
    
    public String toString() {
      return "0.001";
    }
    
    public $generated__7_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * trials.indices
   */
  private static Iterable<Index<String>> $generated__8(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    Collection<Index<String>> _indices = trials.indices();
    return _indices;
  }
  
  /**
   * Auxiliary method generated to translate:
   * efficacies.get(trial)
   */
  private static RealVar $generated__9(final Index<String> trial, final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    RealVar _get = efficacies.get(trial);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * a
   */
  private static RealVar $generated__10(final RealVar a, final RealVar b) {
    return a;
  }
  
  public static class $generated__10_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__10(a, b);
    }
    
    public String toString() {
      return "a";
    }
    
    private final RealVar a;
    
    private final RealVar b;
    
    public $generated__10_class(final RealVar a, final RealVar b) {
      this.a = a;
      this.b = b;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * b
   */
  private static RealVar $generated__11(final RealVar a, final RealVar b) {
    return b;
  }
  
  public static class $generated__11_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__11(a, b);
    }
    
    public String toString() {
      return "b";
    }
    
    private final RealVar a;
    
    private final RealVar b;
    
    public $generated__11_class(final RealVar a, final RealVar b) {
      this.a = a;
      this.b = b;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * incidences.get(trial)
   */
  private static RealVar $generated__12(final Index<String> trial, final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    RealVar _get = incidences.get(trial);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * c
   */
  private static RealVar $generated__13(final RealVar c, final RealVar d) {
    return c;
  }
  
  public static class $generated__13_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__13(c, d);
    }
    
    public String toString() {
      return "c";
    }
    
    private final RealVar c;
    
    private final RealVar d;
    
    public $generated__13_class(final RealVar c, final RealVar d) {
      this.c = c;
      this.d = d;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * d
   */
  private static RealVar $generated__14(final RealVar c, final RealVar d) {
    return d;
  }
  
  public static class $generated__14_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__14(c, d);
    }
    
    public String toString() {
      return "d";
    }
    
    private final RealVar c;
    
    private final RealVar d;
    
    public $generated__14_class(final RealVar c, final RealVar d) {
      this.c = c;
      this.d = d;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * trials.indices
   */
  private static Iterable<Index<String>> $generated__15(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    Collection<Index<String>> _indices = trials.indices();
    return _indices;
  }
  
  /**
   * Auxiliary method generated to translate:
   * arms.indices
   */
  private static Iterable<Index<String>> $generated__16(final Index<String> trial, final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    Collection<Index<String>> _indices = arms.indices();
    return _indices;
  }
  
  /**
   * Auxiliary method generated to translate:
   * groupSizes.get(trial, arm)
   */
  private static IntVar $generated__17(final Index<String> arm, final Index<String> trial, final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    IntVar _get = groupSizes.get(trial, arm);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * if (arm.isControl) 0.0 else efficacies.get(trial)
   */
  private static RealVar $generated__18(final Index<String> arm, final Index<String> trial, final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    RealVar _xifexpression = null;
    boolean _isControl = Utils.isControl(arm);
    if (_isControl) {
      _xifexpression = new blang.core.RealConstant(0.0);
    } else {
      _xifexpression = efficacies.get(trial);
    }
    return _xifexpression;
  }
  
  /**
   * Auxiliary method generated to translate:
   * incidences.get(trial)
   */
  private static RealVar $generated__19(final Index<String> arm, final Index<String> trial, final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    RealVar _get = incidences.get(trial);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * numbersOfCases.get(trial, arm)
   */
  private static IntVar $generated__20(final Index<String> arm, final Index<String> trial, final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c, final RealVar d) {
    IntVar _get = numbersOfCases.get(trial, arm);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * groupSize
   */
  private static IntVar $generated__21(final IntVar groupSize, final RealVar efficacy, final RealVar incidence) {
    return groupSize;
  }
  
  public static class $generated__21_class implements Supplier<IntVar> {
    public IntVar get() {
      return $generated__21(groupSize, efficacy, incidence);
    }
    
    public String toString() {
      return "groupSize";
    }
    
    private final IntVar groupSize;
    
    private final RealVar efficacy;
    
    private final RealVar incidence;
    
    public $generated__21_class(final IntVar groupSize, final RealVar efficacy, final RealVar incidence) {
      this.groupSize = groupSize;
      this.efficacy = efficacy;
      this.incidence = incidence;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * incidence * (1.0 - efficacy)
   */
  private static RealVar $generated__22(final IntVar groupSize, final RealVar efficacy, final RealVar incidence) {
    return new blang.core.RealConstant(((incidence).doubleValue() * (1.0 - (efficacy).doubleValue())));
  }
  
  public static class $generated__22_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__22(groupSize, efficacy, incidence);
    }
    
    public String toString() {
      return "incidence * (1.0 - efficacy)";
    }
    
    private final IntVar groupSize;
    
    private final RealVar efficacy;
    
    private final RealVar incidence;
    
    public $generated__22_class(final IntVar groupSize, final RealVar efficacy, final RealVar incidence) {
      this.groupSize = groupSize;
      this.efficacy = efficacy;
      this.incidence = incidence;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__23(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__24(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__25(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__26(final GlobalDataSource data, final Plate<String> trials, final Plate<String> arms, final Plated<IntVar> groupSizes, final Plated<IntVar> numbersOfCases, final Plated<RealVar> efficacies, final Plated<RealVar> incidences, final RealVar a, final RealVar b, final RealVar c) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public Vaccines(@DeboxedName("numbersOfCases") final Plated<IntVar> numbersOfCases, @DeboxedName("efficacies") final Plated<RealVar> efficacies, @DeboxedName("incidences") final Plated<RealVar> incidences, @DeboxedName("a") final RealVar a, @DeboxedName("b") final RealVar b, @DeboxedName("c") final RealVar c, @DeboxedName("d") final RealVar d, @Param @DeboxedName("data") final Supplier<GlobalDataSource> $generated__data, @Param @DeboxedName("trials") final Supplier<Plate<String>> $generated__trials, @Param @DeboxedName("arms") final Supplier<Plate<String>> $generated__arms, @Param @DeboxedName("groupSizes") final Supplier<Plated<IntVar>> $generated__groupSizes) {
    this.$generated__data = $generated__data;
    this.$generated__trials = $generated__trials;
    this.$generated__arms = $generated__arms;
    this.$generated__groupSizes = $generated__groupSizes;
    this.numbersOfCases = numbersOfCases;
    this.efficacies = efficacies;
    this.incidences = incidences;
    this.a = a;
    this.b = b;
    this.c = c;
    this.d = d;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: a ~ Exponential(0.001)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Exponential(
          $generated__0($generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d), 
          new $generated__1_class()
        )
        );
    }
    { // Code generated by: b ~ Exponential(0.001)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Exponential(
          $generated__2($generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d), 
          new $generated__3_class()
        )
        );
    }
    { // Code generated by: c ~ Exponential(0.001)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Exponential(
          $generated__4($generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d), 
          new $generated__5_class()
        )
        );
    }
    { // Code generated by: d ~ Exponential(0.001)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Exponential(
          $generated__6($generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d), 
          new $generated__7_class()
        )
        );
    }
    for (Index<String> trial : $generated__8($generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d)) {
      { // Code generated by: efficacies.get(trial) | a,b ~ Beta(a, b)
        // Construction and addition of the factor/model:
        components.add(
          new blang.distributions.Beta(
            $generated__9(trial, $generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d), 
            new $generated__10_class(a, b), 
            new $generated__11_class(a, b)
          )
          );
      }
      { // Code generated by: incidences.get(trial) | c,d ~ Beta(c, d)
        // Construction and addition of the factor/model:
        components.add(
          new blang.distributions.Beta(
            $generated__12(trial, $generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d), 
            new $generated__13_class(c, d), 
            new $generated__14_class(c, d)
          )
          );
      }
    }
    for (Index<String> trial : $generated__15($generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d)) {
      for (Index<String> arm : $generated__16(trial, $generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d)) {
        { // Code generated by: numbersOfCases.get(trial, arm) | IntVar groupSize = groupSizes.get(trial, arm), RealVar efficacy = if (arm.isControl) 0.0 else efficacies.get(trial), RealVar incidence = incidences.get(trial) ~ Binomial(groupSize, incidence * (1.0 - efficacy))
          // Required initialization:
          IntVar groupSize = $generated__17(arm, trial, $generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d);
          RealVar efficacy = $generated__18(arm, trial, $generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d);
          RealVar incidence = $generated__19(arm, trial, $generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d);
          // Construction and addition of the factor/model:
          components.add(
            new blang.distributions.Binomial(
              $generated__20(arm, trial, $generated__data.get(), $generated__trials.get(), $generated__arms.get(), $generated__groupSizes.get(), numbersOfCases, efficacies, incidences, a, b, c, d), 
              new $generated__21_class(groupSize, efficacy, incidence), 
              new $generated__22_class(groupSize, efficacy, incidence)
            )
            );
        }
      }
    }
    
    return components;
  }
}
