require("ggplot2")
require("dplyr")

data <- read.csv("/Users/bouchard/w/blogobayes/www/ex/vax/results/all/Vaccines-515213705/samples/efficacies.csv")

# ggplot has bad default sizes for large facetting
verticalSize <- 2.0 *  length(unique(data$trials)) 
horizontalSize <- 4.0


p <- ggplot(data, aes(x = sample, y = value)) +
  geom_point(size = 0.1) + geom_line(alpha = 0.5) + facet_grid(trials ~ .
  , scales="free") + 
  theme_bw() + 
  xlab("MCMC iteration") +
  ylab("sample") +
  ggtitle("Trace plot for: efficacies")
ggsave("/Users/bouchard/w/blogobayes/www/ex/vax/results/all/Vaccines-515213705/tracePlotsFull/efficacies.pdf", limitsize = F, height = verticalSize, width = horizontalSize)
